diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
index 9bdc88504..08c4e334a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
@@ -173,4 +172,8 @@ public abstract class FontRenderer {
     public int stringWidth(final @NotNull CharSequence chars) {
         return stringWidth(getFont(), chars);
     }
+
+    public void init() {
+
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 8155d2e83..6e0d8f18e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -1,14 +1,23 @@
 package net.minecraft.client.render.font;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorBase;
+import net.minecraft.client.render.tessellator.TessellatorColor;
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL41;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -41,12 +50,19 @@ public class FontRendererDefault extends FontRenderer {
         this.random = new Random();
     }
 
+    protected TessellatorFont baseStringTess;
+    protected TessellatorDecorations backgroundStringTess;
+    @Override
+    public void init() {
+        this.baseStringTess = new TessellatorFont("FontRenderDefault Base Tessellator", 0x40000);
+        this.backgroundStringTess = new TessellatorDecorations("FontRenderDefault Deco Tessellator", 0x8000);
+    }
+
     private static final StringBuilder renderStringInternal_colorValue = new StringBuilder();
-    protected void renderStringInternal(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    protected void renderStringInternal(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         double currX = x;
 
         this.random.setSeed(System.currentTimeMillis()/50);
-
         for (int i = 0; i < chars.length(); i++) {
             final char c = chars.charAt(i);
 
@@ -136,10 +152,15 @@ public class FontRendererDefault extends FontRenderer {
             final int tex = charFont.textureForChar(c);
             if (this.currentTex != tex) {
                 this.currentTex = tex;
-                GL11.glBindTexture(GL11.GL_TEXTURE_2D, tex);
+                Shaders.FONT.bind();
+                this.baseStringTess.draw(); // Render mesh on texture change
+                GL41.glBindTexture(GL41.GL_TEXTURE_2D, tex);
+                this.baseStringTess.startDrawing();
             }
 
-            currX += renderCharInternal(charFont, tessellator, c, currX, y, z, SF.getColor(this.currentConfig), shadow);
+            double off = renderCharInternal(charFont, this.baseStringTess, c, currX, y, z, SF.getColor(this.currentConfig), shadow);
+            renderCharInternalDecorations(charFont, this.backgroundStringTess, c, currX, y, z, SF.getColor(this.currentConfig), shadow);
+            currX += off;
         }
 
         if (xPosBuffer != null) {
@@ -153,11 +174,10 @@ public class FontRendererDefault extends FontRenderer {
         }
     }
 
-    protected double renderCharInternal(@NotNull final Font font, @NotNull final Tessellator tessellator, final char c, final double x, final double y, final double z, final int color, boolean shadow) {
+    protected double renderCharInternal(@NotNull final Font font, @NotNull final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final int color, boolean shadow) {
         final int rgb = color & 0xFFFFFF;
         final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
         final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
-        tessellator.startDrawingQuads();
 
         shadow &= !SF.isOutlined(this.currentConfig);
 
@@ -171,13 +191,13 @@ public class FontRendererDefault extends FontRenderer {
             final char randomChar = font.getObfuscatedChar(c, this.random);
 
             if (shadow) {
-                tessellator.setColorRGBA_I(shadowRGB, a);
+                tessellator.setColor2i(shadowRGB, a);
                 font.renderChar(tessellator, randomChar, x + px, y + px, z, SF.isItalic(this.currentConfig));
                 if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, randomChar, x + px2, y + px, z, SF.isItalic(this.currentConfig));
             }
 
             if (SF.isOutlined(this.currentConfig)) {
-                tessellator.setColorRGBA_I((rgb & 0xFCFCFC) >> 2, a);
+                tessellator.setColor2i((rgb & 0xFCFCFC) >> 2, a);
                 final double width = SF.isBold(this.currentConfig) ? 2.05 : 1.05;
                 for (double _x = -1; _x <= width; _x += 1/3d) {
                     for (double _y = -1; _y <= 1.05; _y += 1/3d) {
@@ -186,7 +206,7 @@ public class FontRendererDefault extends FontRenderer {
                 }
             }
 
-            tessellator.setColorRGBA_I(rgb, a);
+            tessellator.setColor2i(rgb, a);
             font.renderChar(tessellator, randomChar, x, y, z, SF.isItalic(this.currentConfig));
             if (SF.isBold(this.currentConfig)) {
                 font.renderChar(tessellator, randomChar, x + px, y, z, SF.isItalic(this.currentConfig));
@@ -195,13 +215,13 @@ public class FontRendererDefault extends FontRenderer {
 
         } else {
             if (shadow) {
-                tessellator.setColorRGBA_I(shadowRGB, a);
+                tessellator.setColor2i(shadowRGB, a);
                 font.renderChar(tessellator, c, x + px, y + px, z, SF.isItalic(this.currentConfig));
                 if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, c, x + px2, y + px, z, SF.isItalic(this.currentConfig));
             }
 
             if (SF.isOutlined(this.currentConfig)) {
-                tessellator.setColorRGBA_I((rgb & 0xFCFCFC) >> 2, a);
+                tessellator.setColor2i((rgb & 0xFCFCFC) >> 2, a);
                 final double width = SF.isBold(this.currentConfig) ? 2.05 : 1.05;
                 for (double _x = -1; _x <= width; _x += 1/3d) {
                     for (double _y = -1; _y <= 1.05; _y += 1/3d) {
@@ -210,91 +230,130 @@ public class FontRendererDefault extends FontRenderer {
                 }
             }
 
-            tessellator.setColorRGBA_I(rgb, a);
+            tessellator.setColor2i(rgb, a);
             shift = font.renderChar(tessellator, c, x, y, z, SF.isItalic(this.currentConfig));
             if (SF.isBold(this.currentConfig)) {
                 font.renderChar(tessellator, c, x + px, y, z, SF.isItalic(this.currentConfig));
                 shift += px;
             }
         }
-        tessellator.draw();
+        return shift;
+    }
+
+    protected void renderCharInternalDecorations(@NotNull final Font font, final @NotNull TessellatorDecorations tessellator, final char c, final double x, final double y, final double z, final int color, boolean shadow) {
+        final int rgb = color & 0xFFFFFF;
+        final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
+        final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
+
+        boolean strikethrough = SF.isStrikethrough(this.currentConfig);
+        boolean underline = SF.isUnderline(this.currentConfig);
+        if (!strikethrough && !underline) return;
+
+        shadow &= !SF.isOutlined(this.currentConfig);
+
+        final double px = 1;
+        final double px2 = px * 2;
+
         final int fontHeight = font.fontHeight();
-        if (SF.isStrikethrough(this.currentConfig)) {
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
-            tessellator.startDrawingQuads();
+        final double shift = SF.isBold(this.currentConfig) ? font.charWidth(c) + px : font.charWidth(c);
+
+        if (strikethrough) {
             if (shadow) {
-                tessellator.setColorRGBA_I(shadowRGB, a);
+                tessellator.setColor2i(shadowRGB, a);
                 tessellator.addVertex(x + px,        y + px + fontHeight / 2d,     0.0D);
                 tessellator.addVertex(x + px + shift,y + px + fontHeight / 2d,     0.0D);
                 tessellator.addVertex(x + px + shift,y + px + fontHeight / 2d - px,0.0D);
                 tessellator.addVertex(x + px,        y + px + fontHeight / 2d - px,0.0D);
             }
-            tessellator.setColorRGBA_I(rgb, a);
+            tessellator.setColor2i(rgb, a);
             tessellator.addVertex(x,        y + fontHeight / 2d,     0.0D);
             tessellator.addVertex(x + shift,y + fontHeight / 2d,     0.0D);
             tessellator.addVertex(x + shift,y + fontHeight / 2d - px,0.0D);
             tessellator.addVertex(x,        y + fontHeight / 2d - px,0.0D);
-            tessellator.draw();
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
 
-        if (SF.isUnderline(this.currentConfig)) {
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
-            tessellator.startDrawingQuads();
+        if (underline) {
             if (shadow) {
-                tessellator.setColorRGBA_I(shadowRGB, a);
+                tessellator.setColor2i(shadowRGB, a);
                 tessellator.addVertex(x,             y + px2 + fontHeight,      0.0D);
                 tessellator.addVertex(x + px + shift,y + px2 + fontHeight,      0.0D);
                 tessellator.addVertex(x + px + shift,y + px2 + fontHeight - px, 0.0D);
                 tessellator.addVertex(x,             y + px2 + fontHeight - px, 0.0D);
             }
-            tessellator.setColorRGBA_I(rgb, a);
+            tessellator.setColor2i(rgb, a);
             tessellator.addVertex(x - px,    y + px + fontHeight,      0.0D);
             tessellator.addVertex(x + shift, y + px + fontHeight,      0.0D);
             tessellator.addVertex(x + shift, y + px + fontHeight - px, 0.0D);
             tessellator.addVertex(x - px,    y + px + fontHeight - px, 0.0D);
-            tessellator.draw();
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
-        return shift;
     }
+
     @Override
-    public void renderDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderDoubleImpl(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
-        renderStringInternal(font, tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.globalSetUniforms(Shaders.FONT);
+        Shaders.FONT.bind();
+        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
+        GLRenderer.globalSetUniforms(Shaders.COLOR);
+
+        this.baseStringTess.startDrawing();
+        this.backgroundStringTess.startDrawingQuads();
+
+        renderStringInternal(font, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+
+        Shaders.FONT.bind();
+        this.baseStringTess.draw();
+        Shaders.COLOR.bind();
+        this.backgroundStringTess.draw();
+
+        GLRenderer.popFrame();
     }
 
     @Override
-    public void renderImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderDoubleImpl(font, tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderImpl(@NotNull final Font font, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderDoubleImpl(font, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void renderCenteredDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderDoubleImpl(font, tessellator, chars, x - stringWidthDouble(chars)/2d, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderCenteredDoubleImpl(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderDoubleImpl(font, chars, x - stringWidthDouble(chars)/2d, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void renderCenteredImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderImpl(font, tessellator, chars, x - stringWidth(chars)/2, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderCenteredImpl(@NotNull final Font font, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderImpl(font, chars, x - stringWidth(chars)/2, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void renderWidthConstrainedDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderWidthConstrainedDoubleImpl(@NotNull final Font font, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
 
         final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
 
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.globalSetUniforms(Shaders.FONT);
+        Shaders.FONT.bind();
+        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
+        GLRenderer.globalSetUniforms(Shaders.COLOR);
+
+        this.baseStringTess.startDrawing();
+        this.backgroundStringTess.startDrawingQuads();
+
         double currY = y;
         switch (alignment) {
             case LEFT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    renderStringInternal(font, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                 }
                 break;
@@ -302,7 +361,7 @@ public class FontRendererDefault extends FontRenderer {
             case RIGHT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    renderStringInternal(font, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                 }
                 break;
@@ -310,12 +369,17 @@ public class FontRendererDefault extends FontRenderer {
             case CENTERED: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidthDouble(line))/2, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    renderStringInternal(font, line, x + (maxWidth - stringWidthDouble(line))/2, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                 }
                 break;
             }
         }
+        Shaders.FONT.bind();
+        this.baseStringTess.draw();
+        Shaders.COLOR.bind();
+        this.backgroundStringTess.draw();
+        GLRenderer.popFrame();
 
         if (xPosBuffer != null) {
             xPosBuffer[0] = x + maxWidth;
@@ -329,19 +393,30 @@ public class FontRendererDefault extends FontRenderer {
     }
 
     @Override
-    public void renderWidthConstrainedImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderWidthConstrainedImpl(@NotNull final Font font, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
 
         final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
 
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.globalSetUniforms(Shaders.FONT);
+        Shaders.FONT.bind();
+        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
+        GLRenderer.globalSetUniforms(Shaders.COLOR);
+
+        this.baseStringTess.startDrawing();
+        this.backgroundStringTess.startDrawingQuads();
+
         int currY = y;
         switch (alignment) {
             case LEFT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    renderStringInternal(font, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                 }
                 break;
@@ -349,7 +424,7 @@ public class FontRendererDefault extends FontRenderer {
             case RIGHT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidth(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    renderStringInternal(font, line, x + (maxWidth - stringWidth(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                 }
                 break;
@@ -357,12 +432,17 @@ public class FontRendererDefault extends FontRenderer {
             case CENTERED: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, (int)(x + (maxWidth - stringWidth(line))/2), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    renderStringInternal(font, line, x + (maxWidth - stringWidth(line))/2, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                 }
                 break;
             }
         }
+        Shaders.FONT.bind();
+        this.baseStringTess.draw();
+        Shaders.COLOR.bind();
+        this.backgroundStringTess.draw();
+        GLRenderer.popFrame();
 
         if (xPosBuffer != null) {
             xPosBuffer[0] = x + maxWidth;
@@ -376,7 +456,7 @@ public class FontRendererDefault extends FontRenderer {
     }
 
     @Override
-    public void renderConstrainedDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, final double maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderConstrainedDoubleImpl(@NotNull final Font font, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, final double maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
@@ -387,27 +467,55 @@ public class FontRendererDefault extends FontRenderer {
         this.localConfigBuffer[0] = baseConfig;
         switch (alignment) {
             case LEFT: {
+                GLRenderer.pushFrame();
+                GLRenderer.enableState(State.BLEND);
+                GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+                GLRenderer.globalSetUniforms(Shaders.FONT);
+                Shaders.FONT.bind();
+                GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
+                GLRenderer.globalSetUniforms(Shaders.COLOR);
+                this.baseStringTess.startDrawing();
+                this.backgroundStringTess.startDrawingQuads();
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    renderStringInternal(font, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
+                Shaders.FONT.bind();
+                this.baseStringTess.draw();
+                Shaders.COLOR.bind();
+                this.backgroundStringTess.draw();
+                GLRenderer.popFrame();
                 break;
             }
             case RIGHT: {
+                GLRenderer.pushFrame();
+                GLRenderer.enableState(State.BLEND);
+                GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+                GLRenderer.globalSetUniforms(Shaders.FONT);
+                Shaders.FONT.bind();
+                GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
+                GLRenderer.globalSetUniforms(Shaders.COLOR);
+                this.baseStringTess.startDrawing();
+                this.backgroundStringTess.startDrawingQuads();
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    renderStringInternal(font, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
+                Shaders.FONT.bind();
+                this.baseStringTess.draw();
+                Shaders.COLOR.bind();
+                this.backgroundStringTess.draw();
+                GLRenderer.popFrame();
                 break;
             }
             case CENTERED: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderCenteredDoubleImpl(font, tessellator, line, x + maxWidth/2, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    renderCenteredDoubleImpl(font, line, x + maxWidth/2, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
@@ -427,8 +535,8 @@ public class FontRendererDefault extends FontRenderer {
     }
 
     @Override
-    public void renderConstrainedImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, final int maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderConstrainedDoubleImpl(font, tessellator, chars, x, y, z, shadow, baseConfig, maxWidth, maxHeight, alignment, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderConstrainedImpl(@NotNull final Font font, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, final int maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderConstrainedDoubleImpl(font, chars, x, y, z, shadow, baseConfig, maxWidth, maxHeight, alignment, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     private static final StringBuilder splitLineIntoConstrainedLine_lineBuilder = new StringBuilder();
